<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00006000TipoDeMedidaService;
use SM\Traits\TResponse;

class Sm00006000TipoDeMedidaController {
    use TResponse;
    protected $tipoMedidaService;

    public function __construct(Sm00006000TipoDeMedidaService $tipoMedidaService) {
        $this->tipoMedidaService = $tipoMedidaService;
    }

    public function getDescTipoMedida(Request $request, Response $response) {
        try {
            $data = $this->tipoMedidaService->getDescTipoMedida();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getVariacaoTipoMedida(Request $request, Response $response) {
        try {
            $data = $this->tipoMedidaService->getVariacaoTipoMedida($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveTabTipoMedida(DTO\Request $request, DTO\Response $response) {
        try {
            $this->tipoMedidaService->saveTabTipoMedida($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function insertVariacaoTipoMedida(DTO\Request $request, DTO\Response $response) {
        try {
            $this->tipoMedidaService->insertVariacaoTipoMedida($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteVariacaoTipoMedida(DTO\Request $request, DTO\Response $response) {
        try {
            $this->tipoMedidaService->deleteVariacaoTipoMedida($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteTipoMedida(DTO\Request $request, DTO\Response $response) {
        try {
            $this->tipoMedidaService->deleteTipoMedida($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
