<?php
namespace SM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00016000TipoAnexoService;
use SM\Traits\TResponse;

class Sm00016000TipoAnexoController {

    use TResponse;

    protected $tipoAnexoService;

    public function __construct(Sm00016000TipoAnexoService $tipoAnexoService) {
        $this->tipoAnexoService = $tipoAnexoService;
    }

    public function getTipoAnexo(Request $request, Response $response) {
        try {
            $data = $this->tipoAnexoService->getTipoAnexo();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarTiposAnexos(Request $request, Response $response){
        try {
            $params = $request->getParameters();
            $this->tipoAnexoService->salvarTiposAnexos($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirTipoAnexo(Request $request, Response $response){
        try {
            $params = $request->getParameters();
            $this->tipoAnexoService->excluirTipoAnexo($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
?>