<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\Sm00024000ModeloDocumentoService;
use SM\Traits\TResponse;

class Sm00024000ModeloDocumentoController extends SMCrud {

  use TResponse;

  protected $ModeloDocumentoService;

  public function __construct($crudService, $environment, Sm00024000ModeloDocumentoService $ModeloDocumentoService) {
        parent::__construct($crudService, $environment);
        $this->ModeloDocumentoService=$ModeloDocumentoService; 
  }

  public function getInformacoesModeloDocumento(Request $request, Response $response) {
    try {
      $data = $this->ModeloDocumentoService->getInformacoesModeloDocumento();
      $this->sendResponse($data, 200);
    } catch (\Exception $ex) {
      $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
   }
  }

  public function inserirModeloDocumento(Request $request, Response $response) {
    try {
      $data = $this->ModeloDocumentoService->inserirModeloDocumento($request->getParameters());
      $this->sendResponse($data, 200);
    } catch (\Exception $ex) {
      $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
   }
  }

  public function deletarModeloDocumento(Request $request, Response $response) {
    try {
      $data = $this->ModeloDocumentoService->deletarModeloDocumento($request->getParameters());
      $this->sendResponse($data, 200);
    } catch (\Exception $ex) {
      $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
   }
  }

  public function deletarAnexoModeloDocumento(Request $request, Response $response) {
    try {
      $this->ModeloDocumentoService->limparAnexoModeloDocumento($request->getParameters());
    } catch (\Exception $ex) {
      $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
    }
  }

  public function downloadAnexoModeloDocumento(Request $request, Response $response) {
    $nrorg = $request->getParameters()["nrorg"];
    $nrseqmoddocfct = $request->getParameters()["nrseqmoddocfct"];
    $this->ModeloDocumentoService->downloadAnexoModeloDocumento($nrorg, $nrseqmoddocfct);
  }
}
?>