<?php

namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00034002DescontoPeriodoCarenciaPerfilAcessoService;
use SM\Traits\TResponse;

class Sm00034002DescontoPeriodoCarenciaPerfilAcessoController extends SMCrud
{

    use TResponse;

    protected $descontoPeriodoPerfilAcessoService;

    public function __construct($crudService, $environment, Sm00034002DescontoPeriodoCarenciaPerfilAcessoService $descontoPeriodoPerfilAcessoService)
    {
        parent::__construct($crudService, $environment);
        $this->descontoPeriodoPerfilAcessoService = $descontoPeriodoPerfilAcessoService;
    }

    public function getDescontoPeriodoCarenciaPerfilAcesso(Request $request, Response $response)
    {
        try {
            $data = $this->descontoPeriodoPerfilAcessoService->getDescontoPeriodoCarenciaPerfilAcesso();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inserirDescontoPeriodoCarenciaPerfilAcesso(DTO\Request $request, DTO\Response $response)
    {
        try {
            $this->descontoPeriodoPerfilAcessoService->inserirDescontoPeriodoCarenciaPerfilAcesso($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletarDescontoPeriodoCarenciaPerfilAcesso(DTO\Request $request, DTO\Response $response)
    {
        try {
            $this->descontoPeriodoPerfilAcessoService->deletarDescontoPeriodoCarenciaPerfilAcesso($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
