<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00001002PropostaHistoricoFactory {

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getHistoricoProposta() {

        $sql = "SELECT DISTINCT OPALT.NMOPERADOR AS NMOPERALTERACAO,
                                LOG.CDOPERALTERACAO,
                                LOG.NRLOGDADOSPROP,
                                OPRESP.NMOPERADOR AS NMOPERRESPONSAVEL,
                                PROP.CDOPERRESPONSAVEL,
                                LOG.NRSEQORCAMENTO,
                                MOD.NMORCAMENTOMODELO,
                                PROP.NRORCAMENTOMODELO,
                                PROP.IDSITUACAOORCAMENTO,
                                LOG.NRITEMORCAMENTO,
                                LOG.DSCAMPOALTERADO,
                                DECODE(INSTR(UPPER(LOG.DSCAMPOALTERADO), 'DATA'), 0, NVL(LOG.DSVALORANTIGO, LOG.VALORANTIGO), TO_CHAR(TO_DATE(NVL(LOG.DSVALORANTIGO, LOG.VALORANTIGO), 'DD/MM/YYYY HH24:MI:SS'), 'DD/MM/YYYY')) AS DSVALORANTIGO,
                                DECODE(INSTR(UPPER(LOG.DSCAMPOALTERADO), 'DATA'), 0, NVL(LOG.DSVALORNOVO, LOG.VALORNOVO), TO_CHAR(TO_DATE(NVL(LOG.DSVALORNOVO, LOG.VALORNOVO), 'DD/MM/YYYY HH24:MI:SS'), 'DD/MM/YYYY')) AS DSVALORNOVO,
                                LOG.NRORG,
                                TO_CHAR(PROP.DTREFORCAMENTO,'DD/MM/YYYY') AS DTREFORCAMENTO,
                                TO_CHAR(PROP.DTACEITEORCA,'DD/MM/YYYY') AS DTACEITEORCA,
                                LOG.DTALTERACAO,
                                PROP.DSREFERENCIAORCA,
                                ITEM.NMITEMORCAMENTO,
                                PARC.NMPRINCIPALPARC,
                                PROP.NRPARCNEGOCIO,
                                MOD.IDASSELETRDIGITAL,
                                NVL(PROP.NRORCAMENTO, LOG.VALORANTIGO) AS NRORCAMENTO
                        FROM FCT_LOGDADOSPROP LOG
                        LEFT JOIN FCT_ORCAMENTO PROP
                        ON LOG.NRSEQORCAMENTO = PROP.NRSEQORCAMENTO
                        LEFT JOIN FCT_ITEMORCAMENTO ITEM
                        ON LOG.NRITEMORCAMENTO = ITEM.NRITEMORCAMENTO
                        AND LOG.NRSEQORCAMENTO = ITEM.NRSEQORCAMENTO
                        LEFT JOIN PARCNEGOCIO PARC
                        ON PROP.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                        LEFT JOIN OPERADOR OPALT
                        ON LOG.CDOPERALTERACAO = OPALT.CDOPERADOR
                        LEFT JOIN OPERADOR OPRESP
                        ON PROP.CDOPERRESPONSAVEL = OPRESP.CDOPERADOR
                        LEFT JOIN FCT_ORCAMENTOMODELO MOD
                        ON PROP.NRORCAMENTOMODELO = MOD.NRORCAMENTOMODELO";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
?>