<?php

namespace SM\Service;

use SM\Factory\Sm00029001TipoLocalAtendimentoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;

class Sm00029001TipoLocalAtendimentoService {

    protected $Sm00029001TipoLocalAtendimentoFactory;
    protected $Environment;
    protected $newCode;

    
     public function __construct (EntityManager $entityManager, Sm00029001TipoLocalAtendimentoFactory $Sm00029001TipoLocalAtendimentoFactory, Environment $Environment, NewCode $newCode) {
        $this->Sm00029001TipoLocalAtendimentoFactory = $Sm00029001TipoLocalAtendimentoFactory;
        $this->connection                   = $entityManager->getConnection();
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;

    }

    public function getTipoLocalAtendimento() {
      return $this->Sm00029001TipoLocalAtendimentoFactory->getTipoLocalAtendimento();
    }
    
    public function salvarTipoLocalAtendimento($parametros) {
      $cdoperador = $this->Environment->getCdOperador();
      $NRORG = $this->Environment->getNrOrg();
      $this->connection->beginTransaction();
      try{
        foreach($parametros as $chave => $classification){
          if($classification["NRTIPOESTRUTURA"] == 0){
            $NRTIPOESTRUTURA = $this->newCode->getCodeByTableName("TIPOESTRUTURA", $NRORG, 1, 10, true);
            $dataParam = array(
              "NRTIPOESTRUTURA" => $NRTIPOESTRUTURA,
              "NMTIPOESTRUTURA"   => $classification["NMTIPOESTRUTURA"],
              "NRORG"              => $NRORG,
              "NRORGINCLUSAO"      => $NRORG,
              "CDOPERINCLUSAO"     => $cdoperador,
              "IDATIVO"            => "S",

            );
            $this->Sm00029001TipoLocalAtendimentoFactory->salvarTipoLocalAtendimento($dataParam);
          }else{
            $dataParam = array(
              "NRTIPOESTRUTURA"=> $classification["NRTIPOESTRUTURA"],
              "NMTIPOESTRUTURA"  => $classification["NMTIPOESTRUTURA"],
              "CDOPERULTATU"      => $cdoperador, 
              "NRORGULTATU"       => $NRORG,
            );
            $this->Sm00029001TipoLocalAtendimentoFactory->atualizarTipoLocalAtendimento($dataParam);
          }
        }
        $this->connection->commit();
      } catch(\Exception $e) {
          $this->connection->rollback();
          throw $e;
      }
    }
    
    public function deletarTipoLocalAtendimento($parametros) {
      $this->connection->beginTransaction();
      try{
        foreach($parametros as $chave => $classification){
          $dataParam = array( "NRTIPOESTRUTURA" => $classification["NRTIPOESTRUTURA"],);
          $this->Sm00029001TipoLocalAtendimentoFactory->deletarTipoLocalAtendimento($dataParam);
        }
        $this->connection->commit();
      }catch(\Exception $e){
          $this->connection->rollback();
          throw $e;
      }
    }
}